# -*- coding: UTF-8 -*-
"""vues en fenêtres splittees de la répartition de qos
c'est un imbriquation de : 

  GtkHPaned
    GtkDrawingArea
...

  GtkHPaned
    GtkDrawingArea

en autant de fois que de zones

"""

import gtk
import pango
import random

try: _
except: _ = str

# largeur totale de la fenetre de partage
WIDTH = 750
# hauteur de la fenetre de partage
HEIGHT = 55

# tout sauf le noir (c'est utilise pour le texte)
COLORS = ['#FF0000', '#00FF00', '#67D3D7', '#CEBFDC', '#FFFFFF', '#E3AA57', '#21DA37', '#615DAE']

from decimal import Decimal as dec

def average(value, total=WIDTH):
    "calcul de moyenne (largeur par defaut"
    return str(dec(value) / dec(total) * dec('100') )

class QosShareWindow:
    """Fenêtre de partage de Qos """
    def __init__(self, glade_file):
        self.glade_file = glade_file
        self.glade = gtk.glade.XML(self.glade_file,"bwshare_dialog", "editeur")
        self.bwshare = self.glade.get_widget('bwshare_dialog')
        self.container_widget = self.glade.get_widget('bwshare_hpaned')
        self.libelle_widget = self.glade.get_widget('bwshare_libelles_vbox')
        # boites de rangement des zones 
        self.zboxes = []
        # largeur par defaut des zones
        self.width = 200
        # largeur totale
        self.total_width = 700
        # les zones de dessins
        self.draws = []
        # resultat du partage (en pourcentages)
        self.shares = {}
        # la zone de travail pour le partage de bande passante
        self.current_zone = None

        handlers = {
            'on_bwshare_okbutton_press_event': self.response, 
            }
        self.glade.signal_autoconnect(handlers)


    def show(self):
        self.bwshare.show_all()
        
    def gen_zones(self, name, zones):
        """construction des zboxes a partir de l'appel des zones
        
        """
        # recuperation des objets zone 
        self.zones = zones
        # on détruit les anciennes zboxes (si la fenetre est rechargee)
        while self.zboxes != []:
            self.zboxes[0].destroy()
            del self.zboxes[0]
        # calcul de la largeur d'une boite

        total = len(zones) -1 
        self.default_width = WIDTH/total
            
        # création des zboxes pour chaque zone, sauf la zone en cours d'edition
        for zone in zones:
            if zone.name == name:
                # definition de la zone courant 
                self.current_zone = zone
            if zone.name != name:
                # si on est arrive a la fin
                if zones.index(zone) == (len(zones) - 1):
                    self.add_box(zone.name, end=True)
                else:
                    self.add_box(zone.name)

    def color_range(self):
        "une couleur differente pour chaque zone"
        rangelist = [r[2] for r in self.draws]
        while 1:
            r = random.randrange(len(COLORS)-1)
            if r not in rangelist:
                break
        return r
        
        
    def area_expose(self, area, event):
        """callback permettant de lier la surface de dessin au widget
        name : nom de la zone"""
        
        for draw, layout, color_indice, name, libelle in self.draws:
            red = gtk.gdk.color_parse(COLORS[color_indice])
            gc = gtk.gdk.GC(draw.window)
            gc.set_rgb_fg_color(red)
            black = gtk.gdk.color_parse('#000000')
            gc_black = gtk.gdk.GC(self.bwshare.window)
            gc_black.set_rgb_fg_color(black)
            # recuperons la largeur du dessin
            width = draw.window.get_size()[0]
            # largeur finale
            self.shares[name] = "%.2f" % float(average(width))
            draw.window.draw_rectangle(gc, True, 0, 0, width, HEIGHT)
            draw.window.draw_layout(gc_black,15, 11, layout)
            libelle.set_label("zone %s : %.2f" % (name, float(self.shares[name]) ))

        
    def add_box(self, name, end=False):
        """ajout d'une zbox        """
        # box = gtk.HBox(False,0)
        # hbox = gtk.HBox(homogeneous=False, spacing=0)
        if not self.zboxes:
            paned = self.container_widget
        else:
            paned = self.zboxes[-1]

        draw = gtk.DrawingArea()

        layout = pango.Layout(self.bwshare.get_pango_context())
        layout.set_text("zone : %s " % name)

        color_indice = self.color_range()

        # label d'affichage de la repartition en pourcentage
        libelle = gtk.Label("zone %s : " % name)
        self.libelle_widget.pack_start(libelle)

        self.draws.append((draw, layout, color_indice, name, libelle))
        # XXFIXME mettre une valeur moyenne pour la largeur
        draw.set_size_request(self.default_width, HEIGHT)
        # paned.pack1(label, resize=False, shrink=False)
        paned.pack1(draw, resize=True, shrink=True)
        self.current_libelle = " zone: %s" % name
        
        draw.connect("expose-event", self.area_expose)


        newpaned = gtk.HPaned()
        if not end:
            paned.pack2(newpaned, resize=True, shrink=True)
        else:
            # XXFIXME terminer le HPaned correctement plutot que de le laisser vide
            pass
        self.zboxes.append(newpaned)
        
    def response(self, *args):
        "callback d'appui sur ok"
        # renseignons les partages de la zone courante
        self.current_zone.shares = self.shares
        
        # print self.shares
        # print sum([dec(val) for val in self.shares.values()])
        
