# -*- coding: UTF-8 -*-
"""Affichage des zones pour la matrice de qos"""

import gtk, gtk.glade
import gobject
import ihm_utils
from qosshare import QosShareWindow

class QosZone:
    """Affiche toutes les zones pour modification de la bandwidth"""

    def __init__(self, glade_file, zones=[]):
        """
        glade: l'objet XML glade
        """
        # flag d'existence ou non de la fenetre de partage de qos
        self.bwshare= False
        self.glade_file = glade_file
        self.glade = gtk.glade.XML(self.glade_file,"qos_zone", "editeur")
        self.dlg = self.glade.get_widget("qos_zone")
        # XXFIXME : trier les zones par niveau de securite ? 
        self.zones=zones

        self.tree_view = self.glade.get_widget('qos_zones_treeview')

        handlers = {'on_qoszone_dialog_response' : self.close,
                    'on_qoszone_treeview_button_press' : self.get_selected,
#                    'on_qoszone_treeview_select_cursor_row' : self.get_selected,
#                    'on_qoszone_treeview_key_press' : self.save,
#                    'on_qos_zone_treeview_button_press': self.get_selected,
#                    'on_qos_zone_treeview_select_cursor_row': self.get_selected,
#                    'on_qos_zone_treeview_cursor_changed': self.get_selected,
#                    'on_qos_zone_button_press': self.get_selected,
#                    'on_btn_valider_clicked': self.get_selected,
                   }

        self.glade.signal_autoconnect(handlers)

        self.store = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING)

        renderer = gtk.CellRendererText()

        column = gtk.TreeViewColumn(_('zone name'), renderer, text= 0)
        column2 = gtk.TreeViewColumn(_('zone level'), renderer, text=1)
        column3 = gtk.TreeViewColumn(_('zone bandwidth'), renderer, text=2)

        self.tree_view.set_model(self.store)
        self.tree_view.append_column(column)
        self.tree_view.append_column(column2)
        self.tree_view.append_column(column3)
        self.populate_zones()

    def populate_zones(self):
        """remplit le listview des zones"""
        for zone in self.zones:
            self.store.append([zone.name, str(zone.level), str(zone.bandwidth)])
#         self.bwshare.show()
#         # passe au premier plan
#         self.bwshare.grab_focus()
#     def close(self, button, code, *args):
#         if code == gtk.RESPONSE_OK:
#             self.tree_view.get_model().foreach(self.save(var),[])
#         self.dlg.hide()

    def save(self, *args):
        print "appel a save"

#     def save_options(self, model, path, current_iter, data):
#         option = str(model.get_value(current_iter,0))
#         actif = model.get_value(current_iter,1)
#         library_store.options[option]=int(actif)

#      def get_selected_clicked(self, treeview, event, *args):
#          """Supprime la directive selectionnée par click
#          """
#          if event.type == gtk.gdk._2BUTTON_PRESS:
#              self.get_selected(treeview)
        
    def get_selected(self, treeview, event, *args):
        """Supprime la directive selectionnée
        """
        if event.type == gtk.gdk._2BUTTON_PRESS:
            selection = self.tree_view.get_selection()
            store, iter_sel = selection.get_selected()
            # recuperons le nom de la zone
            if iter_sel != None:
                name = store.get_value(iter_sel, 0)
                # creons la widget de partage de qos
                if not self.bwshare:
                    self.bwshare = QosShareWindow(self.glade_file)
                self.bwshare.gen_zones(name, self.zones)
                self.bwshare.show()
                
        
    def close(self, button, code, *args):
        # if code == gtk.RESPONSE_OK:
        self.dlg.hide()
        return False

    def show_dialog(self):
        self.dlg.show()
        
